// Version 1.00 03/10/96  First release as an applet.
//         1.01 21/10/96  Calculator now automatically closed
//                        when all documents have been closed.
//                        Calculator is only centred the first
//                        time it is opened.
//         1.02 13/12/98  Can now handle real decimal point
//                        characters (ASCII 183) as well as
//                        the more common plain full stops.
//   1.03 02/05/01  Allow commas in numbers


int calcs_handle;
int calcs_toolbox = 0;
int calcs_total = 0;
int calcs_mem = 0;
int calcs_centre = 1;
int calc_view;
int calcs_x0;
int calcs_y1;





// read number after caret as a string

string calcs_getnumber(int bm)
{
 int c;
 string s;

 while (((c = bmchar(bm)) >= 48 && c <= 57) || c==',')
 {
  if(c!=',') s = s + chars(c);
  bmmove(bm, 1, 0);
 }
 return s;
}

// covert total to a string

string calcs_tot(void)
{
 string s, t;

 s = itos(calcs_total);
 if (s == "0")
  s = "000";
 t = mids(s, 0, slen(s) - 2);
 s = mids(s, slen(s) - 2, 2);
 if (s != "00")
 {
  if (mids(s, 1, 1) != "0")
   t += "." + s;
  else
   t += "." + mids(s, 0, 1);
 }
 return t;
}


// add number to total

void calcs_calc(int f)
{
 int b1, c;
 string s1, s2;

 if(activetype(TEXTFRAME) <= 1)
  return;

 b1 = bmcreate("calcs_b1");
 setbmtocaret(b1);

 // find start of number
 while ((c = bmprevchar(b1)) >= 48 && c <= 57 || (c == 46 || c == 183 || c==','))
  bmmove(b1, 0 , 0);

 // get number before decimal point and add '-' if necessary
 s1 = calcs_getnumber(b1);
 if(c == 45)
  s1 = "-" + s1;

 // get number after the decimal point and add to total
 if ((bmchar(b1) == 46) || (bmchar(b1) == 183))
 {
  bmmove(b1, 1, 0);
  s2 = calcs_getnumber(b1);
 }
 if(f)
  calcs_total -= stoi(s1 + mids(s2 + "00", 0, 2));
 else
  calcs_total += stoi(s1 + mids(s2 + "00", 0, 2));

 bmdelete(b1);
 type("{CDown}");

 writeicon(calcs_handle, 0, calcs_tot());
}



// display calculator, centred first time

void calcs_display(void)
{
 display_window(calcs_handle, 0, (1<<1) | calcs_centre);
 calcs_centre = 0;
}



void calcs_open3(int h,int x0,int y0,int x1,int y1,int scx,int scy,int bh)
{
 if(!calcs_centre)
 {
  x1+=(calcs_x0-x0);
  y0+=(calcs_y1-y1);
  x0=calcs_x0;
  y1=calcs_y1;
 }
 else
 {
  calcs_x0=x0;
  calcs_y1=y1;
 }
 open_window(h,x0,y0,x1,y1,scx,scy,bh);
}


void calcs_open5(int h,int x0,int y0,int x1,int y1,int scx,int scy,int bh)
{
 calcs_x0=x0;
 calcs_y1=y1;
}



// Tick or un-tick 'Calculator' menu entry

int calcs_flags(int entry, string &text)
{
 return(calcs_toolbox);
}




// handler for calc window mouse clicks

void calcs_clicktoolbox(int handle,int icon,int bits,int mx,int my)
{
 if(icon == 1) calcs_calc(0);
 if(icon == 2) calcs_calc(1);
 if(icon == 3) type(calcs_tot());
 if(icon == 4)
 {
  calcs_total = 0;
  writeicon(calcs_handle, 0, calcs_tot());
 }
 if(icon == 5) calcs_mem=calcs_total;
 if(icon == 6)
 {
  calcs_total = calcs_mem;
  writeicon(calcs_handle, 0, calcs_tot());
 }
}


// handler for calcs window close icon

void calcs_closetoolboxs(int handle)
{
 if(handle)
 {
  close_window(handle);
  delete_window(handle);
  calc_view=0;
  calcs_handle=0;
 }
}


void calcs_closetoolbox(int handle)
{
 calcs_closetoolboxs(handle);
 calcs_toolbox=0;
}



void calcs_opentoolbox(int view)
{

 if(view)
 {
  calcs_handle=create_windowparent("calcs_main",viewhandle(view));
  addwindowhandler(0,calcs_handle,"calcs_clicktoolbox");
  addwindowhandler(2,calcs_handle,"calcs_closetoolbox");
  addwindowhandler(3,calcs_handle,"calcs_open3");
  addwindowhandler(5,calcs_handle,"calcs_open5");
  setwindowflags(calcs_handle,8,8);
  writeicon(calcs_handle,0,calcs_tot());
  calc_view=view;
  calcs_display();
 }
}



// deal with 'Calculator' menu entry

int calcs_entry(int entry,int subcode)
{
 if(!calcs_toolbox)
 {
  calcs_toolbox=1;
  calcs_opentoolbox(activeview());
 }
 else
 {
  calcs_closetoolbox(calcs_handle);
 }

 return(0);
}



void calcs_activeview(int user,int view,int gain)
{

 if(gain && calcs_toolbox && view!=calc_view)
 {
  calcs_opentoolbox(view);
 }

 if(!gain && calcs_toolbox && view && view==calc_view)
 {
  calcs_closetoolboxs(calcs_handle);
 }

}



// add 'Calculator' option to 'Applets' menu
// create window and add window handlers

void main(void)
{
 script_menu_initialise();
 script_menu_insert("calcs_entry","calcs_flags","","","{CALCS_00}");

 addeventhandler(0x215, 0, "calcs_activeview");
}

