/*->c.csink */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "wimptext.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "scanplus.h"
#include "deb.h"


#include "dbhi.h"
#include "mhi.h"




#include "str.h"
#include "constants.h"

#include "units.h"




#include "xcolour.h"
#include "xxcolour.h"
#include "cconv.h"


#include "colsep.h"
#include "colseplink.h"
#include "colsepx.h"


#include "csmath.h"


#include "csink.h"









#define INKPAPER     0
#define INKCYAN      1 
#define INKMAGENTA   2
#define INKYELLOW    3
#define INKMY        4
#define INKCY        5
#define INKCM        6
#define INKCMY       7
#define INKKEY       8

#define INKGAMMA     9
#define INKDOT       10
#define INKINK       11
#define INKTABLE     12




typedef struct inkcolourstr
{

 union
 {
  struct
  {
   int x;
   int y;
   int Y;
  } xyY;

  struct
  {
   int X;
   int Y;
   int Z;
  } XYZ;

  int V[3];

 } data;

} inkcolourstr;




#define INKNAMELEN 32



typedef struct inkstr
{
 char         name[INKNAMELEN];
 char         table[INKNAMELEN];
 inkcolourstr colour[9];
 int          gamma[4];
 int          dotgain;
} inkstr;


static inkstr * csinks;
       int      csinkn;






int cmyktab[9][9][9][9];






static int csinktab(int c,int m,int y,int k)
{
 int v000;
 int v001;
 int v010;
 int v011;
 int v100;
 int v101;
 int v110;
 int v111;
 int v00;
 int v01;
 int v10;
 int v11;
 int v1;
 int v0;
 int v;
 int v0000;
 int v0001;
 int v0010;
 int v0011;
 int v0100;
 int v0101;
 int v0110;
 int v0111;
 int v1000;
 int v1001;
 int v1010;
 int v1011;
 int v1100;
 int v1101;
 int v1110;
 int v1111;
 int ks;
 int cs;
 int ms;
 int ys;
 int rgb;



 ks=k;
 cs=c;
 ms=m;
 ys=y;

 k=k>>5;
 m=m>>5;
 c=c>>5;
 y=y>>5;



 v0000=cmyktab[k][m][c][y] & 0xFF;
 v0001=cmyktab[k][m][c][y+1] & 0xFF;
 v0010=cmyktab[k][m][c+1][y] & 0xFF;
 v0011=cmyktab[k][m][c+1][y+1] & 0xFF;
 v0100=cmyktab[k][m+1][c][y] & 0xFF;
 v0101=cmyktab[k][m+1][c][y+1] & 0xFF;
 v0110=cmyktab[k][m+1][c+1][y] & 0xFF;
 v0111=cmyktab[k][m+1][c+1][y+1] & 0xFF;
 v1000=cmyktab[k+1][m][c][y] & 0xFF;
 v1001=cmyktab[k+1][m][c][y+1] & 0xFF;
 v1010=cmyktab[k+1][m][c+1][y] & 0xFF;
 v1011=cmyktab[k+1][m][c+1][y+1] & 0xFF;
 v1100=cmyktab[k+1][m+1][c][y] & 0xFF;
 v1101=cmyktab[k+1][m+1][c][y+1] & 0xFF;
 v1110=cmyktab[k+1][m+1][c+1][y] & 0xFF;
 v1111=cmyktab[k+1][m+1][c+1][y+1] & 0xFF;



 v000=v0000+((v0001-v0000)*(ys & 0x1F))/32;
 v001=v0010+((v0011-v0010)*(ys & 0x1F))/32;
 v010=v0100+((v0101-v0100)*(ys & 0x1F))/32;
 v011=v0110+((v0111-v0110)*(ys & 0x1F))/32;
 v100=v1000+((v1001-v1000)*(ys & 0x1F))/32;
 v101=v1010+((v1011-v1010)*(ys & 0x1F))/32;
 v110=v1100+((v1101-v1100)*(ys & 0x1F))/32;
 v111=v1110+((v1111-v1110)*(ys & 0x1F))/32;


 v00=v000+((v001-v000)*(cs & 0x1F))/32;
 v01=v010+((v011-v010)*(cs & 0x1F))/32;
 v10=v100+((v101-v100)*(cs & 0x1F))/32;
 v11=v110+((v111-v110)*(cs & 0x1F))/32;


 v0=v00+((v01-v00)*(ms & 0x1F))/32;
 v1=v10+((v11-v10)*(ms & 0x1F))/32;

 v=v0+((v1-v0)*(ks & 0x1F))/32;


 rgb=(v & 0xFF);



 v0000=(cmyktab[k][m][c][y]>>8) & 0xFF;
 v0001=(cmyktab[k][m][c][y+1]>>8) & 0xFF;
 v0010=(cmyktab[k][m][c+1][y]>>8) & 0xFF;
 v0011=(cmyktab[k][m][c+1][y+1]>>8) & 0xFF;
 v0100=(cmyktab[k][m+1][c][y]>>8) & 0xFF;
 v0101=(cmyktab[k][m+1][c][y+1]>>8) & 0xFF;
 v0110=(cmyktab[k][m+1][c+1][y]>>8) & 0xFF;
 v0111=(cmyktab[k][m+1][c+1][y+1]>>8) & 0xFF;
 v1000=(cmyktab[k+1][m][c][y]>>8) & 0xFF;
 v1001=(cmyktab[k+1][m][c][y+1]>>8) & 0xFF;
 v1010=(cmyktab[k+1][m][c+1][y]>>8) & 0xFF;
 v1011=(cmyktab[k+1][m][c+1][y+1]>>8) & 0xFF;
 v1100=(cmyktab[k+1][m+1][c][y]>>8) & 0xFF;
 v1101=(cmyktab[k+1][m+1][c][y+1]>>8) & 0xFF;
 v1110=(cmyktab[k+1][m+1][c+1][y]>>8) & 0xFF;
 v1111=(cmyktab[k+1][m+1][c+1][y+1]>>8) & 0xFF;


 v000=v0000+((v0001-v0000)*(ys & 0x1F))/32;
 v001=v0010+((v0011-v0010)*(ys & 0x1F))/32;
 v010=v0100+((v0101-v0100)*(ys & 0x1F))/32;
 v011=v0110+((v0111-v0110)*(ys & 0x1F))/32;
 v100=v1000+((v1001-v1000)*(ys & 0x1F))/32;
 v101=v1010+((v1011-v1010)*(ys & 0x1F))/32;
 v110=v1100+((v1101-v1100)*(ys & 0x1F))/32;
 v111=v1110+((v1111-v1110)*(ys & 0x1F))/32;


 v00=v000+((v001-v000)*(cs & 0x1F))/32;
 v01=v010+((v011-v010)*(cs & 0x1F))/32;
 v10=v100+((v101-v100)*(cs & 0x1F))/32;
 v11=v110+((v111-v110)*(cs & 0x1F))/32;


 v0=v00+((v01-v00)*(ms & 0x1F))/32;
 v1=v10+((v11-v10)*(ms & 0x1F))/32;
                      
 v=v0+((v1-v0)*(ks & 0x1F))/32;


 rgb|=(v & 0xFF)<<8;



 v0000=(cmyktab[k][m][c][y]>>16) & 0xFF;
 v0001=(cmyktab[k][m][c][y+1]>>16) & 0xFF;
 v0010=(cmyktab[k][m][c+1][y]>>16) & 0xFF;
 v0011=(cmyktab[k][m][c+1][y+1]>>16) & 0xFF;
 v0100=(cmyktab[k][m+1][c][y]>>16) & 0xFF;
 v0101=(cmyktab[k][m+1][c][y+1]>>16) & 0xFF;
 v0110=(cmyktab[k][m+1][c+1][y]>>16) & 0xFF;
 v0111=(cmyktab[k][m+1][c+1][y+1]>>16) & 0xFF;
 v1000=(cmyktab[k+1][m][c][y]>>16) & 0xFF;
 v1001=(cmyktab[k+1][m][c][y+1]>>16) & 0xFF;
 v1010=(cmyktab[k+1][m][c+1][y]>>16) & 0xFF;
 v1011=(cmyktab[k+1][m][c+1][y+1]>>16) & 0xFF;
 v1100=(cmyktab[k+1][m+1][c][y]>>16) & 0xFF;
 v1101=(cmyktab[k+1][m+1][c][y+1]>>16) & 0xFF;
 v1110=(cmyktab[k+1][m+1][c+1][y]>>16) & 0xFF;
 v1111=(cmyktab[k+1][m+1][c+1][y+1]>>16) & 0xFF;


 v000=v0000+((v0001-v0000)*(ys & 0x1F))/32;
 v001=v0010+((v0011-v0010)*(ys & 0x1F))/32;
 v010=v0100+((v0101-v0100)*(ys & 0x1F))/32;
 v011=v0110+((v0111-v0110)*(ys & 0x1F))/32;
 v100=v1000+((v1001-v1000)*(ys & 0x1F))/32;
 v101=v1010+((v1011-v1010)*(ys & 0x1F))/32;
 v110=v1100+((v1101-v1100)*(ys & 0x1F))/32;
 v111=v1110+((v1111-v1110)*(ys & 0x1F))/32;


 v00=v000+((v001-v000)*(cs & 0x1F))/32;
 v01=v010+((v011-v010)*(cs & 0x1F))/32;
 v10=v100+((v101-v100)*(cs & 0x1F))/32;
 v11=v110+((v111-v110)*(cs & 0x1F))/32;


 v0=v00+((v01-v00)*(ms & 0x1F))/32;
 v1=v10+((v11-v10)*(ms & 0x1F))/32;

 v=v0+((v1-v0)*(ks & 0x1F))/32;


 rgb|=(v & 0xFF)<<16;

 return(rgb);
}



int csinktabx(int * s,int * d,int size)
{
 int cmyk;

 while(size--)
 {
  cmyk=*s++;
  *d++=csinktab(cmyk&0xFF,(cmyk>>8)&0xFF,(cmyk>>16)&0xFF,(cmyk>>24)&0xFF);
 }

 return(0);
}



static int csinktabbgr(int * s,int * d,int size)
{
 int cmyk;
 int rgb;

 while(size--)
 {
  cmyk=*s++;
  rgb=csinktab(cmyk&0xFF,(cmyk>>8)&0xFF,(cmyk>>16)&0xFF,(cmyk>>24)&0xFF);
  *d++=(rgb & 0xFF00)|((rgb>>16)&0xFF)|((rgb<<16)&0xFF0000);
 }

 return(0);
}





void csinkcmyk2rgb(quadstr * cmyk,quadstr * rgb)
{
 int c;
 int m;
 int y;
 int k;
 int v;

 k=(cmyk->type.cmyk.k*255)/MAXCV;
 c=(cmyk->type.cmyk.c*255)/MAXCV;
 m=(cmyk->type.cmyk.m*255)/MAXCV;
 y=(cmyk->type.cmyk.y*255)/MAXCV;

 v=(k<<24)|(y<<16)|(m<<8)|c;

 csinktabx(&v,&v,1);

 rgb->type.rgb.r=((v & 0xFF)*MAXCV)/255;
 rgb->type.rgb.g=(((v>>8) & 0xFF)*MAXCV)/255;
 rgb->type.rgb.b=(((v>>16) & 0xFF)*MAXCV)/255;
}





/*
os_error * csinkcmyk2rgb32pal(int * s,int * d,int size)
{
 csinktabx(s,d,size);

 while(size--)
 {
  *d++=(*s++)<<8;
 }

 return(NULL);
}

*/


/*

os_error * csinkcmyk2rgb3216(int * s,int * d,int size)
{
 int cmyk;
 int word;
 int shift;
 int rgb;
 int r;
 int g;
 int b;


 word=0; // compiler

 shift=0;

 while(size--)
 {
  cmyk=*s++;

  csinktabx(&cmyk,&rgb,1);

  r=rgb&0xF8;
  g=(rgb>>8)&0xF8;
  b=(rgb>>16)&0xF8;

  if(shift) *d++=(b<<23)|(g<<18)|(r<<13)|word;
  else       word=(b<<7)|(g<<2)|(r>>3);

  shift=1-shift;
 }

 if(shift) *d++=word;

 return(NULL);
}

*/

os_error * csinkcmyk2bgr3216(int * s,int * d,int size)
{
 int cmyk;
 int word;
 int shift;
 int rgb;
 int r;
 int g;
 int b;


 word=0; /* compiler */

 shift=0;

 while(size--)
 {
  cmyk=*s++;

  csinktabx(&cmyk,&rgb,1);

  r=rgb&0xF8;
  g=(rgb>>8)&0xF8;
  b=(rgb>>16)&0xF8;

  if(shift) *d++=(r<<23)|(g<<18)|(b<<13)|word;
  else       word=(r<<7)|(g<<2)|(b>>3);

  shift=1-shift;
 }

 if(shift) *d++=word;

 return(NULL);
}





os_error * csinkcmyk2rgb3232(int * s,int * d,int size)
{
 csinktabx(s,d,size);
 return(NULL);
}



os_error * csinkcmyk2bgr3232(int * s,int * d,int size)
{
 csinktabbgr(s,d,size);
 return(NULL);
}









os_error * csinkrgb2cmyk3232(int * s,int * d,int size)
{

 USE(s);
 USE(d);
 USE(size);

 return(NULL);
}




os_error * csinkbgr2cmyk3232(int * s,int * d,int size)
{

 USE(s);
 USE(d);
 USE(size);

 return(NULL);
}






/*
os_error * csinkrgb2cmykpal32(int * s,int * d,int size)
{

 USE(s);
 USE(d);
 USE(size);

 return(NULL);


}

*/

/*
os_error * csinkrgb2cmyk1632(int * s,int * d,int size)
{

 USE(s);
 USE(d);
 USE(size);

 return(NULL);

}
*/

os_error * csinkbgr2cmyk1632(int * s,int * d,int size)
{

 USE(s);
 USE(d);
 USE(size);

 return(NULL);

}




os_error * csinkrgb32torgb32(int * s,int * d,int size,int key,int mask)
{

 USE(s);
 USE(d);
 USE(size);
 USE(key);
 USE(mask);


 return(NULL);
}






os_error * csinkbgr32tobgr32(int * s,int * d,int size,int key,int mask)
{

 USE(s);
 USE(d);
 USE(size);
 USE(key);
 USE(mask);


 return(NULL);
}





os_error * csinkbgr24tobgr24(int * s,int * d,int size,int key,int mask)
{

 USE(s);
 USE(d);
 USE(size);
 USE(key);
 USE(mask);


 return(NULL);
}






os_error * csinkrgb16torgb16(int * s,int * d,int size,int key,int mask)
{

 USE(s);
 USE(d);
 USE(size);
 USE(key);
 USE(mask);


 return(NULL);
}



os_error * csinkbgr16tobgr16(int * s,int * d,int size,int key,int mask)
{

 USE(s);
 USE(d);
 USE(size);
 USE(key);
 USE(mask);


 return(NULL);
}







/*****************************************************************************/



static void csxyY2XYZ(inkcolourstr * inkc)
{
 int X;
 int Y;
 int Z;

 X=scale(inkc->data.xyY.x,inkc->data.xyY.Y,inkc->data.xyY.y);
 Y=inkc->data.xyY.Y;
 Z=scale(0x10000-inkc->data.xyY.x-inkc->data.xyY.y,inkc->data.xyY.Y,
                                                 inkc->data.xyY.y);
 inkc->data.XYZ.X=X;
 inkc->data.XYZ.Y=Y;
 inkc->data.XYZ.Z=Z;
}




/*
     r=3.240479*Xs-1.53715*Ys-0.498535*Zs
     g=-0.969256*Xs+1.875991*Ys+0.041556*Zs
     b=0.055648*Xs-0.204043*Ys+1.057311*Zs

*/



#define WX ((int)((0.412453+0.35758+0.180423)*(double)0x10000))
#define WY ((int)((0.212671+0.71516+0.072169)*(double)0x10000))
#define WZ ((int)((0.019334+0.11919+0.950227)*(double)0x10000))

#define RX ((int)(3.240479*(double)0x10000))
#define RY ((int)(-1.53715*(double)0x10000))
#define RZ ((int)(-0.498535*(double)0x10000))

#define GX ((int)(-0.969256*(double)0x10000))
#define GY ((int)(1.875991*(double)0x10000))
#define GZ ((int)(0.041556*(double)0x10000))

#define BX ((int)(0.055648*(double)0x10000))
#define BY ((int)(-0.204043*(double)0x10000))
#define BZ ((int)(1.057311*(double)0x10000))



static os_error * maketable(inkstr * ink)
{
 int c;
 int m;
 int y;
 int k;
 int ci;
 int mi;
 int yi;
 int ki;
 int cp;
 int mp;
 int yp;
 int f[9];
 int X[9];
 int Y[9];
 int Z[9];
 int i;
 int Xs;
 int Ys;
 int Zs;
 int r;
 int g;
 int b;



 for(i=0;i<8;i++)
 {
  X[i]=scale(WX,ink->colour[i].data.XYZ.X-ink->colour[INKKEY].data.XYZ.X,
             ink->colour[INKPAPER].data.XYZ.X-ink->colour[INKKEY].data.XYZ.X);

  Y[i]=scale(WY,ink->colour[i].data.XYZ.Y-ink->colour[INKKEY].data.XYZ.Y,
             ink->colour[INKPAPER].data.XYZ.Y-ink->colour[INKKEY].data.XYZ.Y);

  Z[i]=scale(WZ,ink->colour[i].data.XYZ.Z-ink->colour[INKKEY].data.XYZ.Z,
             ink->colour[INKPAPER].data.XYZ.Z-ink->colour[INKKEY].data.XYZ.Z);
 }



 for(ki=k=0;ki<9;k+=32,ki++)
 {
  if(k>255) k=255;

  for(mi=m=0;mi<9;m+=32,mi++)
  {
   if(m>255) m=255;

   for(ci=c=0;ci<9;c+=32,ci++)
   {
    if(c>255) c=255;

    for(yi=y=0;yi<9;y+=32,yi++)
    {
     if(y>255) y=255;

    /* cp=(c+k);if(cp>255) cp=255;
     mp=(m+k);if(mp>255) mp=255;
     yp=(y+k);if(yp>255) yp=255; */

     cp=c;
     mp=m;
     yp=y;

     f[0]=(255-cp)*(255-mp)*(255-yp);
     f[1]=cp*(255-mp)*(255-yp);
     f[2]=mp*(255-cp)*(255-yp);
     f[3]=yp*(255-cp)*(255-mp);
     f[4]=mp*yp*(255-cp);
     f[5]=cp*yp*(255-mp);
     f[6]=cp*mp*(255-yp);
     f[7]=cp*mp*yp;

     Xs=Ys=Zs=0;

     for(i=0;i<8;i++)
     {
      Xs+=scale(scale(f[i],X[i],255*255*255),255-k,255);
      Ys+=scale(scale(f[i],Y[i],255*255*255),255-k,255);
      Zs+=scale(scale(f[i],Z[i],255*255*255),255-k,255);
     }

     r=scale(RX,Xs,0x10000)+scale(RY,Ys,0x10000)+scale(RZ,Zs,0x10000);
     g=scale(GX,Xs,0x10000)+scale(GY,Ys,0x10000)+scale(GZ,Zs,0x10000);
     b=scale(BX,Xs,0x10000)+scale(BY,Ys,0x10000)+scale(BZ,Zs,0x10000);


     r=(r*255)/0x10000;
     g=(g*255)/0x10000;
     b=(b*255)/0x10000;

     if(r<0)   r=0;
     if(r>255) r=255;
     if(g<0)   g=0;
     if(g>255) g=255;
     if(b<0)   b=0;
     if(b>255) b=255;

     cmyktab[ki][mi][ci][yi]=(b<<16)|(g<<8)|r;
    }
   }
  }
 }

 return(NULL);
}




static os_error * setupink(inkstr * ink) 
{
 os_error * err;
 char       string[FILENAMELEN];
 int        type;

 if(*ink->table)
 {
  err=xsprintf(sizeof(string),NULL,string,"%s\\Colsupp\\Resources\\Tables\\%s",colsepbasepath,ink->table);
  if(!err) err=fs_exists(string,&type);
  if(!err && type==1)
  {
   err=fs_loadblock(string,cmyktab);
   if(!err) return(err);
  }
 }

 /* else generate the table */

 return(maketable(ink));
}





/*****************************************************************************/



int csinkname(int fp)
{
 int      * stack;
 int        n;
 char       temp[256];
 int        s;

 stack=xstackptr();

 n=stack[fp];
 s=stack[fp+1];

 if(n>=0 && n<csinkn)
 {
  xzstrncpy(temp,csinks[n].name,sizeof(temp));
  assignstring(s,temp);
  return(1);
 }
 return(0);
}



static int cscurink=-1;

os_error * cssetinkx(int n)
{
 if(n!=cscurink)
 {
  setupink(csinks+n);
  cscurink=n;
 }
 return(NULL);
}



char * csinknameptr(int value)
{
 return(csinks[value].name);
}



int csfindinkname(char * string)
{
 int n;

 for(n=0;n<csinkn;n++)
 {
  if(!cstrcmp(string,csinks[n].name)) return(n);
 }
 return(-1);
}




static char * inktokens[]=
{
 "Paper",
 "Cyan",
 "Magenta",
 "Yellow",
 "MagentaYellow",
 "CyanYellow",
 "CyanMagenta",
 "Black",
 "Key",
 "Gamma",
 "DotGain",
 "Ink",
 "Table",
};



/* a token is a non space, followed by a space or zero */

static char * gettok(char * string,int * len)
{
 int    tlen;
 char * p;
 char * q;

 p=string;
 while(*p==' ') p++;
 q=p;
 while(*q>' ') q++;

 tlen=q-p;
 if(*q)
 {
  *q=0;
  tlen++;
 }

 *len=tlen;

 return(p);
}



#define INKCHUNK (16*sizeof(inkstr))



os_error * csinkinit(char * path)
{
 os_error     * err;
 buffer         bf;
 char           string[128];
 char           buffer[FILENAMELEN];
 int            eof;
 int            len;
 char         * p;
 char         * leaf;
 fxstat         f;
 int            i;
 int            j;



 xzstrncpy(buffer,path,sizeof(buffer));
 strcat(buffer,"\\Colsupp\\Resources\\Inks");

 err=flex_alloc((flex_ptr)&csinks,INKCHUNK);
 csinkn=0;

 if(!err)
 {
  err=initscan(buffer);
  if(!err)
  {
   len=strlen(buffer);
   leaf=buffer+len;
   csinkn=-1;

   while(nextitem(&f))
   {
    err=xsprintf(sizeof(buffer)-len,NULL,leaf,"\\%s",f.name);
    if(!err) err=bf_open(buffer,'r',DEFBUFFSIZE,&bf);
    if(!err)
    {
     eof=0;

     while(!eof)
     {
      err=bf_getstring(&bf,string,sizeof(string),&eof);
      if(err) break;

      p=gettok(string,&len);
      if(len)
      {
       if(strncmp(p,"//",2))
       {
        for(i=0;i<(sizeof(inktokens)/sizeof(int));i++)
        {
         if(!cstrcmp(p,inktokens[i])) break;
        }

        if(i<(sizeof(inktokens)/sizeof(int)))
        {
         if(i==INKINK)
         {
          p+=len;
          while(*p==' ') p++;

          csinkn++;
          err=flex_chunk((flex_ptr)&csinks,(csinkn+1)*sizeof(inkstr),INKCHUNK);
          if(err) break;

          xstrncpy(csinks[csinkn].name,p,INKNAMELEN);
          *csinks[csinkn].table=0;
         }
         else
         if(i==INKDOT)
         {
          p=gettok(p+len,&len);
          if(len)
          {
           stringtonumberxdp(p,&csinks[csinkn].dotgain,5,0);
          }
         }
         else
         if(i==INKTABLE)
         {
          p=gettok(p+len,&len);
          if(len)
          {
           xstrncpy(csinks[csinkn].table,p,INKNAMELEN);
          }
         }
         else
         if(i==INKGAMMA)
         {
          for(j=0;j<4;j++)
          {
           p=gettok(p+len,&len);
           if(len)
           {
            stringtonumberxdp(p,&csinks[csinkn].gamma[j],5,0);
           }
           else break;
          }
         }
         else
         {
          for(j=0;j<3;j++)
          {
           p=gettok(p+len,&len);
           if(len)
           {
            stringtonumberxdp(p,&csinks[csinkn].colour[i].data.V[j],5,0);
           }
          }
         }
        }
       }
      }
     }
     err=bf_close(&bf,err);
    }
   }

   csinkn++;
   if(!err) err=flex_extend((flex_ptr)&csinks,csinkn*sizeof(inkstr));

   if(!err)
   {
    for(i=0;i<csinkn;i++)
    {
     for(j=INKPAPER;j<=INKKEY;j++)
     {
      csxyY2XYZ(&csinks[i].colour[j]);
     }
    }
   }

   endscan();
  }
 }

 return(err);
}


