/*->c.fillhatch */



#include "stdafx.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h> 

#include "os.h"
#include "bbc.h"
#include "sprite.h"
#include "wimp.h"

#include "transform.h"

#include "xprocess.h"



#include "wos.h"
#include "poll.h"
#include "etc.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "sp.h"
#include "task.h"
#include "xhelp.h"
#include "trans.h"
#include "dbhi.h"
#include "key.h"
#include "temp.h"
#include "redraw.h"
#include "xmath.h"
#include "bits.h"

#include "xext.h"



#include "constants.h"
#include "str.h"


#include "file.h"
#include "view.h"
#include "viewo.h"


#include "units.h"

#include "object.h"
#include "select.h"
#include "xredraw.h"
#include "xrender.h"
#include "curve.h"
#include "xxcolour.h"
#include "xcolour.h"
#include "colsep.h"
#include "dbcolour.h"
#include "mhi.h"
#include "dscript.h"
#include "line.h"

#include "geometry.h"




#include "filllink.h"

#include "filltool.h"
#include "dbfill.h"
#include "fill.h"


#include "fillhatch.h"



#define MINRAD (MMRUNITS(1,10))




typedef struct hatchstr
{
 int           x;
 int           y;
 colourvalue   c;
 int           space;
 int           angle;
 int           style;
 int           stylescale;
 int           width;
 int           spare1;
 int           spare2;

} hatchstr;




static hatchstr defhatch[2]=
{
 0,
 0,
 OURBLACK,
 MMSIZE*2,
 -45*0x10000,
 0xFFFFFFFF,    /* solid */
 0x1400,
 MMRUNITS(1,4),  /* 0.25mm */
 0,
 0,

 0,
 0,
 OURBLACK,
 MMSIZE*2,
 -135*0x10000,
 0xFFFFFFFF,    /* solid */
 0x1400,
 MMRUNITS(1,4),  /* 0.25mm */
 0,
 0,
};



static hatchstr chatch[2];
static int      chn;
static int      hcolicon[2]={6,16};





static os_error * hatchpath(coordstr * cx,hatchstr * hatch,
                            viewredrawstr * v,transformstr * tr)
{
 int        path[8];
 pathstyle  pstyle;

 path[0]=DRAWMOVE;
 path[1]=cx[0].x;
 path[2]=cx[0].y;
 path[3]=DRAWDRAW;
 path[4]=cx[1].x;
 path[5]=cx[1].y;
 path[6]=DRAWEND;


 memset(&pstyle,0,sizeof(pathstyle));
 pstyle.style=hatch->style;
 pstyle.stylescale=hatch->stylescale;
 pstyle.thickness=hatch->width;

 pstyle.action=0x1;
 return(rpathlines(path,&pstyle,v,tr));
}




/* abox   - area in OS units to render                 */
/* restr  - transform from fill space to Draw/OS space */
/* filltr - transform from fill space to page space    */
/* tr     - transform from curve space to page space   */


static os_error * hatchrender(aboxstr * abox,transformstr * restr,
                              transformstr * filltr,
                              viewredrawstr * v,curvestr * c,
                              curvestylestr * cstyle,transformstr * tr)

{
 os_error      * err;
 fillobjectstr * fb;
 hatchstr        hatch[2];
 filestr       * file;
 viewstr       * view;
 int             i;
 int             transparent;
 double          angle;
 double          ta;
 int             angle1;
 aboxstr         dbox;
 aboxstr         maxbox1;
 aboxstr         maxbox2;
 aboxstr         cmaxbox1;
 aboxstr         cmaxbox2;
 int             ds;
 int             ht0;
 int             ht1;
 int             cht0;
 int             cht1;
 coordstr        cx[2];
 int             dx;
 int             dy;
 int             x0;
 int             x1;
 int             y0;
 int             y1;
 int             xl;
 int             yl;


 err=NULL;



 file=v->file;
 view=v->view;


 box2abox(&c->box,&cmaxbox1);
 getmaxabox(&dbox,&cmaxbox1,tr);  /* max size of curve in page space */
 getmaxinvabox(&cmaxbox1,&dbox,filltr);

 dbox=*abox;

 dbox.x0*=256;
 dbox.x1*=256;
 dbox.y0*=256;
 dbox.y1*=256;

 getmaxinvabox(&maxbox1,&dbox,restr);



 fb=(fillobjectstr*)fob_find(cstyle->fill.fill,file);
 XMEMCPYX(hatch,((char*)fb)+sizeof(fillobjectstr),2*sizeof(hatchstr));

 for(i=0;i<2;i++)
 {

//  vsetcolour(&hatch[i].c,&transparent,view);
  err=render_setcolour(&hatch[i].c,&transparent,v);
  if(!transparent)
  {
   cmaxbox2=cmaxbox1;
   maxbox2=maxbox1;

   angle1=-hatch[i].angle;

   while(angle1> (90*0x10000)) angle1-=180*0x10000;
   while(angle1<-(90*0x10000)) angle1+=180*0x10000;


   angle=(((double)angle1)/((double)0x10000));
   angle/=180.0;
   angle*=PI;

   if(angle1>=(45*0x10000) || angle1<=(-45*0x10000))
   {  
    cmaxbox2.y0-=hatch[i].width;
    cmaxbox2.y1+=hatch[i].width;
    maxbox2.x0-=hatch[i].width;
    maxbox2.x1+=hatch[i].width;

    ds=(int)(((double)hatch[i].space)/sin(angle));
    if(ds)
    {
     ta=tan(angle);

     ht0=(int)(((double)maxbox2.y0)/ta);
     ht1=(int)(((double)maxbox2.y1)/ta);
     cht0=(int)(((double)cmaxbox2.y0)/ta);
     cht1=(int)(((double)cmaxbox2.y1)/ta);

     /* y1 is > y0 */

     dx=hatch[i].x+(int)((double)hatch[i].y/ta);

     if(angle1>=(45*0x10000))
     {
      x0=maxbox2.x0+ht0;
      x0=(x0-dx)/ds;
      x0*=ds;
      x0+=dx;
      x0-=ht0;
      if(x0>maxbox2.x0) x0-=ds;
      xl=maxbox2.x1+ht1-ht0;
      x1=x0-ht1+ht0;
     }
     else
     {
      ds=-ds;
      x0=maxbox2.x0+ht1;
      x0=(x0-dx)/ds;
      x0*=ds;
      x0+=dx;
      x0-=ht0;
      if(x0>maxbox2.x0) x0-=ds;
      xl=maxbox2.x1;
      x1=x0+ht0-ht1;
     }

     x0=x0-cht0+ht0;
     xl=xl-cht0+ht0;
     x1=x1-cht1+ht1;

     while(x0<xl)
     {
      cx[0].y=cmaxbox2.y0;
      cx[1].y=cmaxbox2.y1;
      cx[0].x=x0;
      cx[1].x=x1;

      hatchpath(cx,&hatch[i],v,restr);

      x0+=ds;
      x1+=ds;
     }
    }
   }
   else
   {
    /* angle between -45 and +45 */

    cmaxbox2.x0-=hatch[i].width;
    cmaxbox2.x1+=hatch[i].width;
    maxbox2.y0-=hatch[i].width;
    maxbox2.y1+=hatch[i].width;

    ds=(int)(((double)hatch[i].space)/cos(angle));
    if(ds)
    {
     ta=tan(PI/2.0-angle);

     ht0=(int)(((double)maxbox2.x0)/ta);
     ht1=(int)(((double)maxbox2.x1)/ta);
     cht0=(int)(((double)cmaxbox2.x0)/ta);
     cht1=(int)(((double)cmaxbox2.x1)/ta);

     dy=hatch[i].y+(int)((double)hatch[i].x/ta);

     if(angle1>=0)
     {
      y0=maxbox2.y0+ht0;
      y0=(y0-dy)/ds;
      y0*=ds;
      y0+=dy;
      y0-=ht0;
      if(y0>maxbox2.y0) y0-=ds;
      yl=maxbox2.y1+ht1-ht0;
      y1=y0-ht1+ht0;
     }
     else
     {
      y0=maxbox2.y0+ht1;
      y0=(y0-dy)/ds;
      y0*=ds;
      y0+=dy;
      y0-=ht0;
      if(y0>maxbox2.y0) y0-=ds;
      yl=maxbox2.y1;
      y1=y0+ht0-ht1;
     }

     y0=y0-cht0+ht0;
     yl=yl-cht0+ht0;
     y1=y1-cht1+ht1;


     while(y0<yl)
     {
      cx[0].x=cmaxbox2.x0;
      cx[1].x=cmaxbox2.x1;
      cx[0].y=y0;
      cx[1].y=y1;

      hatchpath(cx,&hatch[i],v,restr);

      y0+=ds;
      y1+=ds;
     }
    }
   }
  }
 }

 return(err);
}





static os_error * hatchcreates(filestr * file,filldatastr * data,
                               hatchstr * chatchp,fillstr * xnew,int xprocess)
{
 os_error      * err;
 fillobjectstr * fillp;
 hatchstr      * hatchp;
 int             process;

 err=NULL;


 if(xprocess) process=xprocess;
 else
 {
  err=copyprocess(data->process,&process,file);
 }

 if(!err)
 {
  err=fob_create(sizeof(fillobjectstr)+2*sizeof(hatchstr),file,
                                                     OFILL,(fobjptr)&fillp);
  if(!err)
  {
   xnew->fill=fillp->key;
   fillp->data=*data;
   fillp->data.process=process;
   fillp->filltype=FL_HATCH;
   hatchp=(hatchstr*)(((char*)fillp)+sizeof(fillobjectstr));
   XMEMCPYX(hatchp,chatchp,2*sizeof(hatchstr));
  }
  else
  {
   deleteprocess(process,file);
  }
 }

 return(err);
}









static os_error * hatchwrite(fillstr * fill,buffer * bf,filestr * file)
{
 os_error      * err;
 fillobjectstr * fb;
 hatchstr      * hatch;
 int             i;

 err=NULL;

 fb=(fillobjectstr*)fob_find(fill->fill,file);
 if(fb)
 {
  hatch=(hatchstr*)(((char*)fb)+sizeof(fillobjectstr));

  err=bf_printfeol(bf,"{fill {hatch ");
  if(!err)
  {
   for(i=0;i<2;i++)
   {
             err=bf_printfeol(bf,"{thickness %d}",hatch[i].width);
    if(!err) err=bf_printfeol(bf,"{linecolour %s}",
                            dscvstring2(&hatch[i].c,file));

    if(!err) err=bf_printfeol(bf,"{linestyle 0x%x %d}",
                            hatch[i].style,hatch[i].stylescale);

    if(!err) err=bf_printfeol(bf,"{x %d}",hatch[i].x);
    if(!err) err=bf_printfeol(bf,"{y %d}",hatch[i].y);

    if(!err) err=bf_printfeol(bf,"{w %d}",hatch[i].space);

    if(!err) err=bf_printfeol(bf,"{angle 0x%x}",-hatch[i].angle);
    if(err) break;
   }
  }

  if(!err) err=dswriteprocess(fb->data.process,bf,file);

  if(!err) err=bf_printf(bf,"}\r\n}\r\n");
 }

 return(err);
}




os_error * dshatch(int fp,int argc,objectloc * loc)
{
 os_error          * err;
 int                 sp;
 int                 nsp;
 dsobjectstr       * ds;
 dsobjectstr       * ds1;
 int                 xp;
 int               * dsstack;
 fillstr             fill;
 hatchstr            hatch[2];
 filldatastr         filldata;
 int                 i;
 int                 seenthickness;
 int                 process;



 err=NULL;

 memset(&hatch,0,2*sizeof(hatchstr));
 memset(&filldata,0,sizeof(filldatastr));
 filldata.scale=filldata.aspect=0x10000;

 seenthickness=0;
 i=0;
 process=0;

 sp=fp+2; /* skip leading type/len */
 xp=sp;

 dsstack=dsstackptr();


 while(argc--)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);

  switch(ds->type)
  {

   case DSTTHICKNESS:
                     if(seenthickness) i=1;
                     else              seenthickness=1;

                     hatch[i].width=ds1->data.integer;
                     break;

  case DSTLINECOLOUR:
                     hatch[i].c.data.tint.key=ds1->data.integer;
                     ds1=(dsobjectstr*)(dsstack+sp+2+3);
                     hatch[i].c.data.tint.tint=ds1->data.integer;
                     if(nsp>(sp+2+6))
                     {
                      ds1=(dsobjectstr*)(dsstack+sp+2+6);
                      hatch[i].c.data.tint.overprint=ds1->data.integer;
                     }
                     break;


   case DSTLINESTYLE:
                     hatch[i].style=ds1->data.integer;
                     ds1=(dsobjectstr*)(dsstack+sp+2+3);
                     hatch[i].stylescale=ds1->data.integer;
                     break;

   case         DSTX:
                     hatch[i].x=ds1->data.integer;
                     break;

   case         DSTY:
                     hatch[i].y=ds1->data.integer;
                     break;

   case         DSTW:
                     hatch[i].space=ds1->data.integer;
                     break;

   case     DSTANGLE:
                     hatch[i].angle=-ds1->data.integer;
                     break;

   case   DSTPROCESS:
                     process=ds->data.integer;
                     break;

  }
  sp=nsp;
 }


 err=hatchcreates(loc->file,&filldata,hatch,&fill,process);
 if(!err)
 {
  dsstack=dsstackptr();

  ds=(dsobjectstr*)(dsstack+fp);
  ds->len=3*sizeof(int);
  ds->data.integer=fill.fill;
 }

 return(err);

}







static os_error * hatchcopy(fillstr * d,filestr * dfile,
                         fillstr * s,filestr * sfile,int mode)
{
 os_error      * err;
 fillobjectstr * fillp;
 hatchstr        hatch[2];
 int             sprocess;
 int             dprocess;


 fillp=(fillobjectstr*)fob_find(s->fill,sfile);
 sprocess=fillp->data.process;

 err=copyprocessm(&dprocess,dfile,sprocess,sfile,mode);
 if(!err)
 {
  err=fob_copy((fobjptr)&fillp,dfile,s->fill,sfile);
  if(!err)
  {
   d->fill=fillp->key;
   fillp->data.process=dprocess;

   if(sfile!=dfile)
   {
    XMEMCPYX(hatch,(((char*)fillp)+sizeof(fillobjectstr)),2*sizeof(hatchstr));
    mapcolour(sfile,dfile,&hatch[0].c,mode);
    mapcolour(sfile,dfile,&hatch[1].c,mode);
    fob_mod(d->fill,dfile,(fobjptr)&fillp);
    XMEMCPYX((((char*)fillp)+sizeof(fillobjectstr)),hatch,2*sizeof(hatchstr));
   }
  }
  else
  {
   deleteprocess(dprocess,dfile);
   d->fill=0;
  }
 }
 else
 {
  d->fill=0;
 }


 return(err);
}






static os_error * hatchcreate(filestr * file,filldatastr * data,
                                             fillstr * xnew,fillstr * old)
{
 os_error * err;

 err=hatchcreates(file,data,chatch,xnew,0);

 return(err);

 USE(old);
}




static os_error * hatchapply(filestr * file,filltoolstr * tool,
                                                 fillstr * xnew,fillstr * old)
{
 os_error      * err;
 fillobjectstr * fob;
 hatchstr      * hatchp;
 int             process;

 err=copyprocess(tool->process,&process,file);
 if(!err)
 {
  if(old && old->fill) err=fob_copy((fobjptr)&fob,file,old->fill,file);
  else                 err=fob_create(sizeof(fillobjectstr)+2*sizeof(hatchstr),
                                                    file,OFILL,(fobjptr)&fob);
  if(!err)
  {
   xnew->fill=fob->key;
   fob->filltype=FL_HATCH;
   hatchp=(hatchstr*)(((char*)fob)+sizeof(fillobjectstr));

   if(!old || !old->fill) XMEMCPYX(hatchp,&chatch,2*sizeof(hatchstr));

   hatchp[1].x+=tool->x-hatchp[0].x;
   hatchp[0].x+=tool->x-hatchp[0].x;
   hatchp[1].y+=tool->y-hatchp[1].y;
   hatchp[0].y+=tool->y-hatchp[0].y;

   hatchp[0].space=ttmul(tool->rx,tool->scale);
   hatchp[0].space=FLOOR(hatchp[0].space,MINRAD);
   hatchp[1].space=ttmul(tool->ry,ttmul(tool->scale,tool->aspect));
   hatchp[1].space=FLOOR(hatchp[1].space,MINRAD);

   hatchp[0].angle=tool->angle;
   hatchp[1].angle=tool->angle-tool->skew-90*0x10000;

   hatchp[0].c=tool->c1;
   hatchp[1].c=tool->c2;

   fob->data.scale=0x10000;
   fob->data.aspect=0x10000;
   fob->data.process=process;
  }
  else
  {
   deleteprocess(process,file);
  }
 }
 return(err);
}



static os_error * hatchtool(filestr * file,filltoolstr * tool,fillstr * old)
{
 fillobjectstr * fob;
 hatchstr      * hatchp;



 if(old)
 {
  fob=(fillobjectstr*)fob_find(old->fill,file);
  hatchp=(hatchstr*)(((char*)fob)+sizeof(fillobjectstr));

  tool->process=fob->data.process;
  tool->x=hatchp[0].x;
  tool->y=hatchp[0].y;
  tool->rx=hatchp[0].space;
  tool->ry=hatchp[1].space;
  tool->angle=hatchp[0].angle;
  tool->skew=hatchp[0].angle-hatchp[1].angle-90*0x10000;
  tool->c1=hatchp[0].c;
  tool->c2=hatchp[1].c;
  tool->filltype=fob->filltype;
  tool->scale=0x10000;
  tool->aspect=0x10000;
 }
 else
 {
  tool->process=0;
  tool->x=chatch[0].x;
  tool->y=chatch[0].y;
  tool->rx=chatch[0].space;
  tool->ry=chatch[1].space;
  tool->angle=chatch[0].angle;
  tool->skew=chatch[0].angle-chatch[1].angle-90*0x10000;
  tool->c1=chatch[0].c;
  tool->c2=chatch[1].c;
  tool->filltype=FL_HATCH;
  tool->scale=0x10000;
  tool->aspect=0x10000;
 }

 return(NULL);
}





/***************************************************************************/

extern dboxstr hatchbox;

static viewstr * cview;
static filestr * cfile;

static dboxstr * cparent;



static os_error * outu(int value,char * string)
{
 strcpy(string,unitstostring(value,cview->data.units));
 return(NULL);
}


static os_error * inu(int * value,char * string)
{
 return(stringtounits(string,value,cview->data.units));
}



static os_error * outr(int value,char * string)
{
 strcpy(string,unitstostring(value,cview->data.units));
 return(NULL);
}


static os_error * inr(int * value,char * string)
{
 os_error * err;

 err=stringtounits(string,value,cview->data.units);
 if(!err)
 {
  *value=FLOOR((*value),MINRAD);
 }

 return(err);
}




static os_error * wrwidth(int value,char * string)
{
 if(value) return(outu(value,string));
 else
 {
  tsprintf(32,string,"{THIN}");
  return(NULL);
 }
}



static os_error * rdwidth(int * value,char * string)
{
 os_error * err;
 char       temp[64];

 err=NULL;

 tsprintf(sizeof(temp),temp,"{THIN}");
 if(!cstrcmp(temp,string)) *value=0;
 else                      err=inu(value,string);

 return(err);
}







static os_error * hatchredrawsub(int handle,wimp_redrawstr *redrawstr,int more)
{
 os_error * err;
 int        i;

 err=NULL;

 while(more)
 {
  for(i=0;i<2;i++)
  {
   redrawblock(redrawstr,handle,hcolicon[i],
                                   vfindcolour2(NULL,cfile,&chatch[i].c));
  }
  wimp_get_rectangle(redrawstr,&more);
 }

 return(err);
}



static os_error * hatchredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;

 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) hatchredrawsub(handle,&redrawstr,more);
 return(err);

 USE(userhandle);
}







static void hatchpickclose(colourvalue * colour)
{
 chatch[chn].c=*colour;
 wimp_set_icon_state(hatchbox.handle,hcolicon[chn],
                                     (wimp_iconflags)0,(wimp_iconflags)0);
}





static os_error * hatchicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
  case  8: /* colour 1 */
          chn=0;
          err=pickcolour(cfile,&chatch[0].c,hatchpickclose,
                                                       (dboxstr*)userhandle);
          break;

  case 10: /* colour 2 */
          chn=1;
          err=pickcolour(cfile,&chatch[1].c,hatchpickclose,
                                                       (dboxstr*)userhandle);
          break;

  case  9: /* pattern 1 */
          chn=0;
          err=openmenuparent("hatchstyle_menu",handle);
          break;

  case 14: /* pattern 2 */
          chn=1;
          err=openmenuparent("hatchstyle_menu",handle);
          break;

  case 20: /* width 1 */
          chn=0;
          err=openmenuparent("hatchwidth_menu",handle);
          break;

  case 22: /* width 2 */
          chn=1;
          err=openmenuparent("hatchwidth_menu",handle);
          break;
 }

 return(err);

 USE(handle);
 USE(userhandle);
}









static dbiconstr hatchicondefs[]=
{
 /* N   &V           Type     Grp   Flags   Msk Key   ESG   -   clickfn 0 */

    2, &chatch[0].x,     DBWRITE,  0,   0,    -1, -1, 3,-1,    inu, outu,
   24, &chatch[1].x,     DBWRITE,  0,   0,    -1, -1, 3,-1,    inu, outu,

    3, &chatch[0].y,     DBWRITE,  0,   0,    -1, -1, 3,-1,    inu, outu,
   25, &chatch[1].y,     DBWRITE,  0,   0,    -1, -1, 3,-1,    inu, outu,

   12, &chatch[0].space, DBWRITE,  0,   0,    -1, -1, 3,-1,    inr, outr,
   27, &chatch[1].space, DBWRITE,  0,   0,    -1, -1, 3,-1,    inr, outr,

   13, &chatch[0].angle, DBWRITE,  0,   0,    -1, -1,-1,7,readangle,writeangle,
   28, &chatch[1].angle, DBWRITE,  0,   0,    -1, -1,-1,7,readangle,writeangle,

    5, &chatch[0].style, DBTEXT,   0,   0,     0,0,0,0,        NULL,NULL,
   15, &chatch[1].style, DBTEXT,   0,   0,     0,0,0,0,        NULL,NULL,

   19, &chatch[0].width, DBWRITE,  0,   0,     0,0,0,0,        rdwidth,wrwidth,
   21, &chatch[1].width, DBWRITE,  0,   0,     0,0,0,0,        rdwidth,wrwidth,


 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};






void sethatchwidth(int fp)
{
 int * stack;
 stack=xstackptr();
 chatch[chn].width=stack[fp];
 dbchangevalue(&chatch[chn].width,cparent);
}


int gethatchwidth(int fp)
{
 return(chatch[chn].width);
 USE(fp);
}


void sethatchpattern(int fp)
{
 int * stack;
 stack=xstackptr();
 chatch[chn].style=stack[fp];
 chatch[chn].stylescale=stack[fp+1];
 dbchangevalue(&chatch[chn].style,cparent);
}


int gethatchpattern(int fp)
{
 return(chatch[chn].style);
 USE(fp);
}


int gethatchscale(int fp)
{
 return(chatch[chn].stylescale);
 USE(fp);
}








static dboxstr hatchbox=
{
 0,
 TFILLHATCH,
 DBPANE,
 0,
 NULL,
 hatchicon,
 NULL,
 hatchredraw,
 hatchicondefs,
 0,
 0,
 0,NULL,
 0,
 0,

};




static os_error * hatchpane(int open,fillstr * fill,
                                             viewstr * view,dboxstr * parent)
{
 fillobjectstr * fb;

 if(open)
 {
  cview=view;
  cfile=cview->file;
  cparent=parent;

  if(!fill->fill)
  {
   XMEMCPYX(chatch,defhatch,2*sizeof(hatchstr));
  }
  else
  {
   fb=(fillobjectstr*)fob_find(fill->fill,cfile);
   if(fb->filltype==FL_HATCH)
   {
    XMEMCPYX(chatch,((char*)fb)+sizeof(fillobjectstr),2*sizeof(hatchstr));
   }
   else
   {
    XMEMCPYX(chatch,defhatch,2*sizeof(hatchstr));
   }
  }
 }

 return(NULL);
}






static fillblockstr hatchblock=
{
 0,0,0,0,


 FL_HATCH,

 NULL,
 hatchcopy,
 NULL,
 hatchwrite,

 "{FIL02}",
 &hatchbox,


 hatchpane,
 hatchrender,
 hatchcreate,
 0,
 hatchapply,
 hatchtool,

 NULL,         /* no direct render */

};





os_error * fillhatchinit(void)
{
 return(filllinkblock(&hatchblock));
}

